Array#pack is broken for long strings in buffer
Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.7: REQUIRED, 3.0: REQUIRED, 3.1:

DONE

Description

Array#pack is broken for long strings in the buffer.

See this failure:

n = [ 65, 66, 67 ]

super_long_string = "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa

aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa"

assert_equal(n.pack("@3ccc", buffer: super_long_string), "aaaABC")

# => <internal:pack>:144:in `pack': can't set length of shared string (RuntimeError)

 from (irb):6:in `<main>'

 from /opt/rubies/3.1.2/lib/ruby/gems/3.1.0/gems/irb-1.4.1/exe/irb:11:in `<top (required)>'

 from /opt/rubies/3.1.2/bin/irb:25:in `load'

 from /opt/rubies/3.1.2/bin/irb:25:in `<main>'

Associated revisions

Revision 199b59f065ce6f1c13b8424f35a70c513523211b - 11/10/2022 02:26 PM - jemmai (Jemma Issroff)

Fix bug in array pack with shared strings

If string literals are long and they become shared, we need to make them

independent before we can write to them. [Bug #19116]

Revision 199b59f065ce6f1c13b8424f35a70c513523211b - 11/10/2022 02:26 PM - jemmai (Jemma Issroff)

Fix bug in array pack with shared strings

If string literals are long and they become shared, we need to make them

independent before we can write to them. [Bug #19116]

Revision 199b59f0 - 11/10/2022 02:26 PM - jemmai (Jemma Issroff)

Fix bug in array pack with shared strings

If string literals are long and they become shared, we need to make them

independent before we can write to them. [Bug #19116]

Revision db1aa39ffcaa5b9f062639eb30c76959f4607a8e - 11/13/2022 02:13 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 199b59f065ce6f1c13b8424f35a70c513523211b: [Backport #19116]

    Fix bug in array pack with shared strings

    If string literals are long and they become shared, we need to make them

    independent before we can write to them. [Bug #19116]
    ---

     pack.c                  | 1 +

     test/ruby/test_array.rb | 6 ++++++

     2 files changed, 7 insertions(+)

Revision db1aa39ffcaa5b9f062639eb30c76959f4607a8e - 11/13/2022 02:13 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 199b59f065ce6f1c13b8424f35a70c513523211b: [Backport #19116]

    Fix bug in array pack with shared strings

    If string literals are long and they become shared, we need to make them

    independent before we can write to them. [Bug #19116]

    ---

     pack.c                  | 1 +

     test/ruby/test_array.rb | 6 ++++++

     2 files changed, 7 insertions(+)

Revision db1aa39f - 11/13/2022 02:13 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 199b59f065ce6f1c13b8424f35a70c513523211b: [Backport #19116]

    Fix bug in array pack with shared strings

    If string literals are long and they become shared, we need to make them

    independent before we can write to them. [Bug #19116]

    ---

     pack.c                  | 1 +

     test/ruby/test_array.rb | 6 ++++++

     2 files changed, 7 insertions(+)

History

#1 - 11/09/2022 10:16 PM - peterzhu2118 (Peter Zhu)

- Backport changed from 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1: UNKNOWN to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED

#2 - 11/09/2022 10:17 PM - jemmai (Jemma Issroff)

Fix is in this PR

#3 - 11/10/2022 03:11 PM - jemmai (Jemma Issroff)

- Status changed from Open to Closed

Applied in changeset git|199b59f065ce6f1c13b8424f35a70c513523211b.

Fix bug in array pack with shared strings

If string literals are long and they become shared, we need to make them

independent before we can write to them. [Bug #19116]

#4 - 11/13/2022 02:24 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: DONE

ruby_3_1 db1aa39ffcaa5b9f062639eb30c76959f4607a8e merged revision(s) 199b59f065ce6f1c13b8424f35a70c513523211b.
